class Button {
  //variables
  int x = 0;
  int y = 0;
  int l = 0;
  int w = 0;
  String rTxt = "Push Me";
  String aTxt = "I'm Running";
  boolean running = false;
  color rFill = color(100,100,100);
  color aFill = color(255,255,255);
  color rStroke = color(255,255,255);
  color aStroke = color(100,100,100);
  float rWeight = 4;
  float aWeight = 6;

  Button() {

  }
  void setPos (int xPos, int yPos, int xSize, int ySize) {
    x = xPos;
    y = yPos;
    l = xSize;
    w = ySize;
  }
  void setText (String restingText, String activeText) {
    rTxt = restingText;
    aTxt = activeText;
  }
  void force (boolean state) {
    if (state==true) {
      running = true;
    } 
    else {
      running = false;
    } 
  }
  boolean Toggle () {
    if ((mouseX > x && mouseX < x+l) && (mouseY > y && mouseY < y+w)) {
      if (running == true) {
        running = false; 
      }
      else {
        running = true;
      }
    }
    return running;
  }
  void setAppearance (color rsCol, color rfCol, color asCol, color afCol, float rstW, float astW) {
    rStroke = rsCol;
    rFill = rfCol;
    aStroke = asCol;
    aFill = asCol;
    rWeight = rstW;
    aWeight = astW;
  } 
  void draw() {
    color currStroke;
    color currFill;
    float currStW;
    String currText;
    //set vars
    if (running == true) {
      currStroke = aStroke;
      currFill = aFill;
      currStW = aWeight; 
      currText = aTxt;
    } 
    else {
      currStroke = rStroke;
      currFill = rFill;
      currStW = rWeight; 
      currText = rTxt;
    }

    //draw box
    smooth();
    strokeWeight(currStW);
    stroke(currStroke);
    if (currStW == 0) noStroke();
    fill(currFill);
    strokeJoin(ROUND);
    rect(x,y,l,w);
    //draw text
    fill(currStroke);
    int fSize;
    if (l>w*1.2) {
      fSize = int(1.5*l/currText.length());
    } 
    else {
      fSize = int(0.70*l/currText.length());
    }
    textFont(font, fSize);
    textAlign(CENTER);
    smooth();
    text(currText, int(x+l*0.5),int(y+w/2+fSize/2));

  }
}
